;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Aliens'n Tanks: An Amstrad CPC Game 
;;  Copyright (C) 2021 Yaroslav Paslavskiy Danko / Rodrigo Guzmán Escribá / 
;;                     Eduardo David Gómez Saldias / Semag Ohcaco (@SemagOhcaco)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

.module Templates

.include "sys/ai.h.s"
.include "sys/ai_beh.h.s"
.include "sys/patrol.h.s"
.include "resources/patrol_data.h.s"
.include "animations.h.s"
.include "resources/sprites.h.s"
.include "templates.h.s"
.include "entityInfo.s"
.include "sys/items.h.s"

; tiempo hasta que un enemy dispara
t_shoot_timer_enemy_s = 38
t_shoot_timer_enemy = 40
; r for range
t_shoot_timer_enemy_r_l = 54
t_shoot_timer_enemy_r_h = 96

; tiempo de espera hasta disparar despues de bala tile colision
t_shoot_timer_tile_collision = 28

; tiempo hasta que la bala de un enemy se destruye
t_bullet_timer_enemy = 120
; fast
t_bullet_timer_enemy_f = 60

; tiempo hasta que la bala del player se para
t_bullet_timer_player = 8

t_spawner_timer = 45

player_max_bullets = 1

; behaviours tipo follow in axis
t_follow_timer = 20
t_follow_timer_f = 1

; vidas de spaner
t_spawner_max_hp = 3

; ai_aux_l
t_bullet_vel_x = 1
; ai_aux_h
t_bullet_vel_y = 2

; ai_aux_l
t_bullet_vel_x_f = 2
; ai_aux_h
t_bullet_vel_y_f = 4

t_bullet_vel_x_ff = 3
t_bullet_vel_y_ff = 5

t_enemy_vx = 1
t_enemy_vy = 2

t_enemy_vx_f = 2
t_enemy_vy_f = 4


enemy_no_shoot = 0x0000

free_item = 0

entity_blink_time = 41

;====================================================================
; Templates
;====================================================================

; e_ai_aux_l 
; 1 player tiene el axe
; 2 axe se esta lanzando
; 0 axe volviendoj
; patrol_step para la direccion de su axe
;
; e_anim1 indica si es invencible
; e_anim2 indica tiempo invencible
t_player:
   .db #e_type_player
   .db #0x67                                 ; cmp
   .db #0x26                                 ; x
   .db #0xa0                                 ; y
   .db #0x04                                 ; width
   .db #0x0C                                 ; heigth
   .db #0x00                                 ; vx
   .db #0x00                                 ; vy
   .dw #_avocado_p1_sprite_0                            ; sprite
   .db #0x00                                 ; orientation   0 = Right // 1 = Down // 2 = Left // 3 = Up
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #0000
   .db #0x00                                 ; ai_counter
   .db #0                                   ; anim1 
   .db #0                                   ; anim1 
   .db #0                                   ; anim. counter
   .dw #0x0000                               ; input_behaviour
   .dw #0x0000                               ; ai_aim_position
   .db #1                                    ; e_ai_aux_l
   .db #0x00                                 ; e_ai_aux_h
   .db #0x00                                 ; e_patrol_step_l || dir axe b1
   .db #0x00                                 ; e_patrol_step_h || dir axe b2

t_player2:
   .db #e_type_player
   .db #0x67                                 ; cmp
   .db #0x26                                 ; x
   .db #0xa0                                 ; y
   .db #0x04                                 ; width
   .db #0x0C                                 ; heigth
   .db #0x00                                 ; vx
   .db #0x00                                 ; vy
   .dw #_avocado_p2_sprite_0                            ; sprite
   .db #0x00                                 ; orientation   0 = Right // 1 = Down // 2 = Left // 3 = Up
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #0
   .db #0x00                                 ; ai_counter
   .db #0                                   ; anim1 
   .db #0                                   ; anim1 
   .db #0                                   ; anim. counter
   .dw #0x0000                               ; input_behaviour
   .dw #0x0000                               ; ai_aim_position
   .db #1                                 ; e_ai_aux_l
   .db #0x00                                 ; e_ai_aux_h
   .db #0x00                                 ; e_patrol_step_l || dir axe b1
   .db #0x00                                 ; e_patrol_step_h || dir axe b2

; w 12 ;6
; h 16 ;16
t_e_patrol_blue:
   .db #e_type_enemy                         ; type
   .db #0x6b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #3                                   ; width
   .db #8                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_a_patrol_blue
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_e_patrol_pink:
   .db #e_type_enemy                         ; type
   .db #0x6b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #3                                   ; width
   .db #8                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_a_patrol_pink
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_e_patrol_orange:
   .db #e_type_enemy                         ; type
   .db #0x6b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #3                                   ; width
   .db #8                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_a_patrol_orange
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step


t_e_patrol_red:
   .db #e_type_enemy                         ; type
   .db #0x6b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #3                                   ; width
   .db #8                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_a_patrol_red
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_e_letter:
   .db #e_type_enemy                         ; type
   .db #0x6b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #3                                   ; width
   .db #8                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_a_letter
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_e_follow_blue:
   .db #e_type_enemy                         ; type
   .db #0x6b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #3                                   ; width
   .db #8                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_a_follow_blue
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_e_follow_pink:
   .db #e_type_enemy                         ; type
   .db #0x6b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #3                                   ; width
   .db #8                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_a_follow_pink
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_e_follow_orange:
   .db #e_type_enemy                         ; type
   .db #0x6b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #3                                   ; width
   .db #8                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_a_follow_orange
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_e_follow_red:
   .db #e_type_enemy                         ; type
   .db #0x6b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #3                                   ; width
   .db #8                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_a_follow_orange
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_e_seek_blue:
   .db #e_type_enemy                         ; type
   .db #0x6b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #3                                   ; width
   .db #8                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_a_seek_blue
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_e_seek_pink:
   .db #e_type_enemy                         ; type
   .db #0x6b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #3                                   ; width
   .db #8                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_a_seek_pink
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_e_seek_orange:
   .db #e_type_enemy                         ; type
   .db #0x6b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #3                                   ; width
   .db #8                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_a_seek_orange
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_e_seek_red:
   .db #e_type_enemy                         ; type
   .db #0x6b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #3                                   ; width
   .db #8                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_a_seek_red
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_enemy_basic_blue:
   .db #e_type_enemy                         ; type
   .db #0x3b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_ovni_blue_0                      ; sprite
   .db #0x00                                 ; orientation   
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_blue                                  ; animator
   .db #0x01                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_enemy_basic_purple:
   .db #e_type_enemy                         ; type
   .db #0x3b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_ovni_purple_0                      ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_purple                                  ; animator
   .db #0x01                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

t_enemy_basic_red:
   .db #e_type_enemy                         ; type
   .db #0x3b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_ovni_red_0                      ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #ia_no_move                                    ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_red                                  ; animator
   .db #0x01                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #patrol_seeknpatrol_01                                    ; patrol_step


; anim counter : life
t_final_boss:
.db #e_type_enemy                         ; type
.db #0x6b                                 ; cmp
.db #0                                    ; x
.db #0                                    ; y
.db #10                                   ; width
.db #22                                   ; heigth
.db #0                                    ; vx
.db #0                                    ; vy
.dw #_final_boss_09                      ; sprite
.db #0x00                                 ; orientation
.db #0x00                                 ; prev. orientation
.dw #0x0000                               ; prevptr
.dw #ia_no_move                                    ; ai_behaviour
.db #t_shoot_timer_enemy_s
.db #10                                  ; animator1
.db #00                                  ; animator2
.db #00                                  ; anim. counter
.dw #enemy_no_shoot                               ; input_behaviour
.db #0x00                                 ; e_ai_aim_x
.db #0x00                                 ; e_ai_aim_y
.db #0                                    ; e_ai_aux_l
.db #0                                    ; e_ai_aux_h
.dw #0                                    ; patrol_step

   ; .db #e_type_enemy                         ; type
   ; .db #0x6b                                 ; cmp
   ; .db #0                                    ; x
   ; .db #0                                    ; y
   ; .db #10                                    ; width
   ; .db #22                                   ; heigth
   ; .db #0                                    ; vx
   ; .db #0                                    ; vy
   ; .dw #_final_boss_09                      ; sprite
   ; .db #0x00                                 ; orientation
   ; .db #0x00                                 ; prev. orientation
   ; .dw #0x0000                               ; prevptr
   ; .dw #ia_no_move                                    ; ai_behaviour
   ; .db #t_shoot_timer_enemy_s
   ; .db #10
   ; .db #0
   ; .db #0                                  ; anim. counter
   ; .dw #enemy_no_shoot                               ; input_behaviour
   ; .db #0x00                                 ; e_ai_aim_x
   ; .db #0x00                                 ; e_ai_aim_y
   ; .db #0                                    ; e_ai_aux_l
   ; .db #0                                    ; e_ai_aux_h
   ; .dw #0                                    ; patrol_step

t_enemy_seeknpatrol:
   .db #e_type_enemy                                 ; type
   .db #0x3b                                 ; cmp
   .db #00                                 ; x
   .db #00                                 ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0x00                                 ; vx
   .db #0x00                                 ; vy
   .dw #_ovni_red_0                      ; sprite
   .db #0x00                                 ; orientation   0 = Right // 1 = Down // 2 = Left // 3 = Up
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_behaviourSeekAndPatrol              ; ai_behaviour
   .db #t_shoot_timer_enemy_s                                 ; ai_counter
   .dw #_man_anim_enemy_red                                  ; animator
   .db #0x0A                                 ; anim. counter
   .dw #0x0000                               ; input_behaviour
   .db #0                                 ; e_ai_aim_x
   .db #0                                 ; e_ai_aim_y
   .db #t_follow_timer                                 ; e_ai_aux_l
   .db #t_follow_timer                                 ; e_ai_aux_h
   .dw #patrol_seeknpatrol_01

t_enemy_seeknpatrol_02:
   .db #e_type_enemy                                 ; type
   .db #0x3b                                 ; cmp
   .db #00                                 ; x
   .db #00                                 ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0x00                                 ; vx
   .db #0x00                                 ; vy
   .dw #_ovni_red_0                      ; sprite
   .db #0x00                                 ; orientation   0 = Right // 1 = Down // 2 = Left // 3 = Up
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_behaviourSeekAndPatrol              ; ai_behaviour
   .db #t_shoot_timer_enemy_s                                 ; ai_counter
   .dw #_man_anim_enemy_red                                  ; animator
   .db #0x0A                                 ; anim. counter
   .dw #0x0000                               ; input_behaviour
   .db #0                                 ; e_ai_aim_x
   .db #0                                 ; e_ai_aim_y
   .db #t_follow_timer                                 ; e_ai_aux_l
   .db #t_follow_timer                                 ; e_ai_aux_h
   .dw #patrol_seeknpatrol_02

t_enemy_patrol_game_zone:
   .db #e_type_enemy                         ; type
   .db #0x3b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_ovni_purple_0                      ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_behaviourPatrol      ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_purple                                  ; animator
   .db #0x0                                  ; anim. counter
   .dw #_sys_ai_beh_shoot_seekplayer                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #patrol_all_game_zone_0m                                    ; patrol_step

t_enemy_patrol_game_zone_i:
   .db #e_type_enemy                         ; type
   .db #0x3b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_ovni_purple_0                      ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_behaviourPatrol      ; ai_behaviour
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_purple                                  ; animator
   .db #0x0                                  ; anim. counter
   .dw #_sys_ai_beh_shoot_seekplayer                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #patrol_all_game_zone_0m_i                                    ; patrol_step

;=====================================================================
; BULLETS
;=====================================================================

; cmp cambia entre 0 y 0x2b
t_axe_player:
   .db #e_type_bullet                        ; type
   .db #0x0                                ; cmp
   .db #0x00                                 ; x
   .db #0x00                                 ; y
   .db #2                                 ; width
   .db #6                                 ; heigth
   .db #0x00                                 ; vx
   .db #0x00                                 ; vy
   .dw #_avocado_axe_1_sprite               ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #sys_ai_beh_axe_follow              ; ai_behaviour
   .db #t_bullet_timer_player               ; ai_counter 
   .dw #0x00                                 ; animator
   .db #0x00                                 ; anim. counter
   .dw #0x0000                               ; input_behaviour
   .dw #0x0000                               ; ai_aim_position
   .db #0x00                                 ; e_ai_aux_l
   .db #0x00                                 ; e_ai_aux_h
   .db #0x00                                 ; e_patrol_step_l || dir player b1
   .db #0x00                                 ; e_patrol_step_h || dir player b2

t_axe_player2:
   .db #e_type_bullet                        ; type
   .db #0x0                                ; cmp
   .db #0x00                                 ; x
   .db #0x00                                 ; y
   .db #2                                 ; width
   .db #6                                 ; heigth
   .db #0x00                                 ; vx
   .db #0x00                                 ; vy
   .dw #_avocado_axe_2_sprite               ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #sys_ai_beh_axe_follow              ; ai_behaviour
   .db #t_bullet_timer_player               ; ai_counter 
   .dw #0x00                                 ; animator
   .db #0x00                                 ; anim. counter
   .dw #0x0000                               ; input_behaviour
   .dw #0x0000                               ; ai_aim_position
   .db #0x00                                 ; e_ai_aux_l
   .db #0x00                                 ; e_ai_aux_h
   .db #0x00                                 ; e_patrol_step_l || dir player b1
   .db #0x00                                 ; e_patrol_step_h || dir player b2


;; la bullet del enemey
t_bullet_enemy_sp:
   .db #e_type_enemy_bullet                                 ; type
   .db #0x6B                                 ; cmp
   .db #0x00                                 ; x
   .db #0x00                                 ; y
   .db #01                                 ; width
   .db #04                                 ; heigth
   .db #0x01                                 ; vx
   .db #0x01                                 ; vy
   .dw #_ovni_bullet_2                     ; sprite
   .db #0x00                                 ; orientation   0 = Right // 1 = Down // 2 = Left // 3 = Up
   .dw #0x0000                               ; prevptr
   .db #0x00                                 ; prev. orientation
   .dw #_sys_ai_behaviourBulletSeektoPlayer  ; ai_behaviour
   .db #t_bullet_timer_enemy                 ; ai_counter   ;; Contador de la bala
   .dw #_man_anim_enemy_bullet                                 ; animator
   .db #0x01                                 ; anim. counter
   ; ! si es 1 es tipo sp
   .dw #0x0001                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #t_bullet_vel_x                                  ; e_ai_aux_l
   .db #t_bullet_vel_y                                 ; e_ai_aux_h
   .db #0x00                                 ; e_patrol_step_l
   .db #0x00                                 ; e_patrol_step_h

t_bullet_enemy_l:
   .db #e_type_enemy_bullet                                 ; type
   .db #0x6B                                 ; cmp
   .db #50
   .db #150
   .db #01                                 ; width
   .db #04                                 ; heigth
   .db #0x00                                 ; vx
   .db #0x00                                 ; vy
   .dw #_ovni_bullet_0                     ; sprite
   .db #0x00                                 ; orientation   0 = Right // 1 = Down // 2 = Left // 3 = Up
   .dw #0x0000                               ; prevptr
   .db #0x00                                 ; prev. orientation
   .dw #_sys_ai_behaviourBulletLinear; ai_behaviour
   .db #t_bullet_timer_enemy                 ; ai_counter   ;; Contador de la bala
   .dw #_man_anim_enemy_bullet                                 ; animator
   .db #0x01                                 ; anim. counter
   .dw #0x0000                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #t_bullet_vel_x                                  ; e_ai_aux_l
   .db #t_bullet_vel_y                                 ; e_ai_aux_h
   .db #0x00                                 ; e_patrol_step_l
   .db #0x00                                 ; e_patrol_step_h

t_bullet_enemy_l_f:
   .db #e_type_enemy_bullet                                 ; type
   .db #0x6B                                 ; cmp
   .db #50
   .db #150
   .db #01                                 ; width
   .db #04                                 ; heigth
   .db #0x00                                 ; vx
   .db #0x00                                 ; vy
   .dw #_ovni_bullet_1                     ; sprite
   .db #0x00                                 ; orientation   0 = Right // 1 = Down // 2 = Left // 3 = Up
   .dw #0x0000                               ; prevptr
   .db #0x00                                 ; prev. orientation
   .dw #_sys_ai_behaviourBulletLinear; ai_behaviour
   .db #t_bullet_timer_enemy_f                 ; ai_counter   ;; Contador de la bala
   .dw #_man_anim_enemy_bullet                                 ; animator
   .db #0x01                                 ; anim. counter
   .dw #0x0000                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #t_bullet_vel_x_f                                  ; e_ai_aux_l
   .db #t_bullet_vel_y_f                                 ; e_ai_aux_h
   .db #0x00                                 ; e_patrol_step_l
   .db #0x00                                 ; e_patrol_step_h




;=====================================================================
; ENEMY TEMPLATES FOR SPAWNER
;=====================================================================
t_es_01:
   .db #e_type_enemy                         ; type
   .db #0x3b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_ovni_blue_0                      ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_behaviourPatrol
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_blue                                  ; animator
   .db #0x1                                  ; anim. counter
   .dw #_sys_ai_beh_shoot_xy_rand                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #patrol_07                                    ; patrol_step

t_es_02:
   .db #e_type_enemy                         ; type
   .db #0x3b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_ovni_purple_0                      ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_beh_follow_player_y
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_purple                                  ; animator
   .db #0x1                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #20                                    ; e_ai_aux_l
   .db #20                                    ; e_ai_aux_h
   .dw #patrol_07                                    ; patrol_step

t_es_03:
   .db #e_type_enemy                         ; type
   .db #0x3b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_ovni_green_0                      ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_behaviourPatrolRelative_f
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_green                                  ; animator
   .db #0x1                                  ; anim. counter
   .dw #enemy_no_shoot                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #54                                    ; e_ai_aux_l
   .db #80                                    ; e_ai_aux_h
   .dw #patrol_relative_around_01                                    ; patrol_step

t_es_04:
   .db #e_type_enemy                         ; type
   .db #0x3b                                 ; cmp
   .db #4                                    ; x
   .db #174                                    ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_ovni_blue_0                      ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_behaviourPatrolRelative
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_blue                  ; animator
   .db #0x1                                  ; anim. counter
   .dw #_sys_ai_beh_shoot_xy_rand                       ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #patrol_09                                    ; patrol_step

t_es_05:
   .db #e_type_enemy                         ; type
   .db #0x3b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_ovni_purple_0                      ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_beh_follow_player_y
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_purple                                  ; animator
   .db #0x1                                  ; anim. counter
   .dw #_sys_ai_beh_shoot_d                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #20                                    ; e_ai_aux_l
   .db #20                                    ; e_ai_aux_h
   .dw #patrol_07                                    ; patrol_step

t_es_06:
   .db #e_type_enemy                         ; type
   .db #0x3b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_ovni_blue_0                      ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_behaviourPatrolRelative_f
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_blue
   .db #0x1                                  ; anim. counter
   .dw #_sys_ai_beh_shoot_seekplayer                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #20                                    ; e_ai_aux_l
   .db #140                                    ; e_ai_aux_h
   .dw #patrol_relative_x_36                                    ; patrol_step

t_es_07:
   .db #e_type_enemy                         ; type
   .db #0x3b                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_ovni_blue_0                      ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_behaviourPatrolRelative
   .db #t_shoot_timer_enemy_s
   .dw #_man_anim_enemy_blue
   .db #0x1                                  ; anim. counter
   .dw #_sys_ai_beh_shoot_d                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #36                                    ; e_ai_aux_l
   .db #108                                    ; e_ai_aux_h
   .dw #patrol_relative_around_01                                    ; patrol_step

t_es_08:
   .db #e_type_enemy                                 ; type
   .db #0x3b                                 ; cmp
   .db #00                                 ; x
   .db #00                                 ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0x00                                 ; vx
   .db #0x00                                 ; vy
   .dw #_ovni_red_0                      ; sprite
   .db #0x00                                 ; orientation   0 = Right // 1 = Down // 2 = Left // 3 = Up
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_behaviourSeekAndPatrol              ; ai_behaviour
   .db #t_shoot_timer_enemy_s                                 ; ai_counter
   .dw #_man_anim_enemy_red                                  ; animator
   .db #0x01                                 ; anim. counter
   .dw #_sys_ai_beh_shoot_seekplayer                               ; input_behaviour
   .db #0                                 ; e_ai_aim_x
   .db #0                                 ; e_ai_aim_y
   .db #t_follow_timer                                 ; e_ai_aux_l
   .db #t_follow_timer                                 ; e_ai_aux_h
   .dw #patrol_seeknpatrol_03

t_es_09:
   .db #e_type_enemy                                 ; type
   .db #0x3b                                 ; cmp
   .db #00                                 ; x
   .db #00                                 ; y
   .db #4                                   ; width
   .db #12                                   ; heigth
   .db #0x00                                 ; vx
   .db #0x00                                 ; vy
   .dw #_ovni_red_0                      ; sprite
   .db #0x00                                 ; orientation   0 = Right // 1 = Down // 2 = Left // 3 = Up
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_behaviourSeekAndPatrol              ; ai_behaviour
   .db #t_shoot_timer_enemy_s                                 ; ai_counter
   .dw #_man_anim_enemy_red                                  ; animator
   .db #0x01                                 ; anim. counter
   .dw #_sys_ai_beh_shoot_xy_rand_f                               ; input_behaviour
   .db #0                                 ; e_ai_aim_x
   .db #0                                 ; e_ai_aim_y
   .db #t_follow_timer                                 ; e_ai_aux_l
   .db #t_follow_timer                                 ; e_ai_aux_h
   .dw #patrol_seeknpatrol_01


;====================================================================
; Pickable items
;====================================================================
item_life_time = 141

; e_ai_aim_y: precio item
; patrol: funcion que ejecuta al pick
t_item_heart:
   .db #e_type_item                                 ; type
   .db #0x29                                 ; cmp
   .db #50                                 ; x
   .db #50                                 ; y
   .db #7                                 ; width
   .db #16                                 ; heigth
   .db #0                                 ; vx
   .db #0x00                                 ; vy
   .dw #_heart_item_sprite                      ; sprite
   .db #0x00                                 ; orientation   
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_beh_item_update
   .db #item_life_time
   .dw #item_pick_heart
   .db #0                                 ; anim. counter
   .dw #0                                    ; input_behaviour
   .db #0                                 ; e_ai_aim_x
   .db #10                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0x00                                 ; e_ai_aux_h
   .dw #0                                    ; e_patrol_step

t_item_heart_free:
   .db #e_type_item                                 ; type
   .db #0x29                                 ; cmp
   .db #50                                 ; x
   .db #50                                 ; y
   .db #7                                 ; width
   .db #16                                 ; heigth
   .db #0                                 ; vx
   .db #0x00                                 ; vy
   .dw #_heart_item_free_sprite                      ; sprite
   .db #0x00                                 ; orientation   
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_beh_item_update
   .db #item_life_time
   .dw #item_pick_heart
   .db #0                                 ; anim. counter
   .dw #0                                    ; input_behaviour
   .db #0                                 ; e_ai_aim_x
   .db #free_item                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0x00                                 ; e_ai_aux_h
   .dw #0                                    ; e_patrol_step

t_item_speed_bullet:
   .db #e_type_item                                 ; type
   .db #0x29                                 ; cmp
   .db #50                                 ; x
   .db #50                                 ; y
   .db #7                                 ; width
   .db #16                                 ; heigth
   .db #0                                 ; vx
   .db #0x00                                 ; vy
   .dw #_speed_b_item_sprite
   .db #0x00                                 ; oriee ntation   
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_beh_item_update
   .db #item_life_time
   .dw #item_pick_speed_bullet
   .db #0                                 ; anim. counter
   .dw #0                                    ; input_behaviour
   .db #0                                 ; e_ai_aim_x
   .db #35                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0x00                                 ; e_ai_aux_h
   .dw #0                                    ; e_patrol_step

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; old items
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
t_item_shield:
   .db #e_type_item                                 ; type
   .db #0x21                                 ; cmp
   .db #50                                 ; x
   .db #50                                 ; y
   .db #7                                 ; width
   .db #16                                 ; heigth
   .db #0x00                                 ; vx
   .db #0x00                                 ; vy
   .dw #_shield_item_sprite                      ; sprite
   .db #0x00                                 ; orientation   0 = Right // 1 = Down // 2 = Left // 3 = Up
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #0
   .db #0
   .dw #item_pick_shield                                  ; animator
   .db #0x0A                                 ; anim. counter
   .dw #0                                    ; input_behaviour
   .db #i_id_shield                                 ; e_ai_aim_x
   .db #0                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0x00                                 ; e_ai_aux_h
   .dw #0                                    ; e_patrol_step

t_item_rotator:
   .db #e_type_item                                 ; type
   .db #0x21                                 ; cmp
   .db #50                                 ; x
   .db #50                                 ; y
   .db #7                                 ; width
   .db #16                                 ; heigth
   .db #0x00                                 ; vx
   .db #0x00                                 ; vy
   .dw #_rotator_item_sprite                      ; sprite
   .db #0x00                                 ; orientation   0 = Right // 1 = Down // 2 = Left // 3 = Up
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #0
   .db #0
   .dw #item_pick_rotator                                  ; animator
   .db #0x0A                                 ; anim. counter
   .dw #0                                    ; input_behaviour
   .db #i_id_rotator                                 ; e_ai_aim_x
   .db #0                                ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0x00                                 ; e_ai_aux_h
   .dw #0                                    ; e_patrol_step

t_item_sharp_bullet:
   .db #e_type_item                                 ; type
   .db #0x21                                 ; cmp
   .db #50                                 ; x
   .db #50                                 ; y
   .db #7                                 ; width
   .db #16                                 ; heigth
   .db #0x00                                 ; vx
   .db #0x00                                 ; vy
   .dw #_sharp_bullet_sprite                      ; sprite
   .db #0x00                                 ; orientation   0 = Right // 1 = Down // 2 = Left // 3 = Up
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #0
   .db #0
   .dw #item_pick_sharp_bullet                                  ; animator
   .db #0x0A                                 ; anim. counter
   .dw #0                                    ; input_behaviour
   .db #i_id_sharp_bullet                                 ; e_ai_aim_x
   .db #0                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0x00                                 ; e_ai_aux_h
   .dw #0                                    ; e_patrol_step

;====================================================================
; Ingame items
;====================================================================

; type_bullet puede servir??
t_ingame_shield:
   .db #e_type_bullet                         ; type
   .db #0x2B                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #6                                   ; width
   .db #16                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_shield_ingame_sprite                      ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_beh_ingame_shield            ; ai_behaviour
   .db #0
   .dw #0                                  ; animator
   .db #0                                  ; anim. counter
   .dw #0                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #0                                    ; patrol_step

; input_behaviour: id de ingame item
t_ingame_rotator:
   .db #e_type_bullet                         ; type
   .db #0x2B                                 ; cmp
   .db #0                                    ; x
   .db #0                                    ; y
   .db #2                                   ; width
   .db #6                                   ; heigth
   .db #0                                    ; vx
   .db #0                                    ; vy
   .dw #_avocado_axe_1_sprite                      ; sprite
   .db #0x00                                 ; orientation
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_beh_ingame_rotator            ; ai_behaviour
   .db #0
   .dw #0                                  ; animator
   .db #0                                  ; anim. counter
   .dw #i_id_rotator                               ; input_behaviour
   .db #0x00                                 ; e_ai_aim_x
   .db #0x00                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                    ; e_ai_aux_h
   .dw #patrol_relative_around_03            ; patrol_step

next_wave_life_time = 42

; TODO
item_none:
   ret

t_next_wave_anim:
   .db #e_type_item                                 ; type
   .db #0x09                                 ; cmp
   .db #22                                 ; x
   .db #112                                 ; y
   .db #36                                 ; width
   .db #14                                 ; hee igth
   .db #0                                 ; vx
   .db #0x00                                 ; vy
   .dw #_next_wave_sprite                      ; sprite
   .db #0x00                                 ; orientation   
   .db #0x00                                 ; prev. orientation
   .dw #0x0000                               ; prevptr
   .dw #_sys_ai_beh_item_update
   .db #next_wave_life_time
   .dw #item_none
   .db #0                                 ; anim. counter
   .dw #0                                    ; input_behaviour
   .db #0                                 ; e_ai_aim_x
   .db #0                                 ; e_ai_aim_y
   .db #0                                    ; e_ai_aux_l
   .db #0                                 ; e_ai_aux_h
   .dw #0                                    ; e_patrol_step

; TODO UPDATE resto items

